
class DetectFileChange(object):
	def __init__(self,file):
		import os
		self.mtime = os.stat(file).st_mtime
		self.file=file
	def __call__(self):
		import os
		import time
		if os.stat(self.file).st_mtime != self.mtime:
			print "File Change detected!"
			time.sleep(0.5)
			self.mtime = os.stat(self.file).st_mtime
			zort.plugins.python.Python.exec_file(self.file,dict())

first_run = False
if not "developing" in zort.globals:
	zort.globals["developing"] = dict()
	zort.globals["developing"]["timer"] = zort.plugins.timing.Timing.timer(10)
	first_run=True
	
g = zort.globals["developing"]
g["event"] = event = event = zort.plugins.timing.Timing.createEvent()
g["timer"].event = event
event.connect(DetectFileChange("./developing.py"))

if first_run:
	print "developing.py registered ... loading user stuff"

####### user stuff here

class funky_draw(object):
	def __init__(self):
		self.context = None
		self.dead = False
		self.spinned_x = 0.0
		self.spinned_y = 0.0
		# generate triangles
		import math
		# goldene schnitt
		ratio = ( 1.0 + math.sqrt(5.0) ) / 2.0
		a = 0.7
		b = 0.7/ratio
		# a > b
		points = [
			# rectangle 1
			[ (b,a,0),(-b,a,0),(-b,-a,0),(b,-a,0) ],
			# rectangle 2
			[ (0,b,a),(0,-b,a),(0,-b,-a),(0,b,-a) ],
			# rectangle 3
			[ (a,0,b),(a,0,-b),(-a,0,-b),(-a,0,b) ],
		]
		
		# generate triangles
		self.triangles = []
		
		# rect 1 pos ratio
		self.triangles += [ [ points[0][0], points[0][1], points[1][0]]  ]
		self.triangles += [ [ points[0][0], points[0][1], points[1][3]]  ]
		# rect 1 neg ratio
		self.triangles += [ [ points[0][2], points[0][3], points[1][1]]  ]
		self.triangles += [ [ points[0][2], points[0][3], points[1][2]]  ]
		# rect 2 pos ratio
		self.triangles += [ [ points[1][0], points[1][1], points[2][0]]  ]
		self.triangles += [ [ points[1][0], points[1][1], points[2][3]]  ]
		# rect 2 neg ratio
		self.triangles += [ [ points[1][2], points[1][3], points[2][1]]  ]
		self.triangles += [ [ points[1][2], points[1][3], points[2][2]]  ]
		# rect 3 pos ratio
		self.triangles += [ [ points[2][0], points[2][1], points[0][0]]  ]
		self.triangles += [ [ points[2][0], points[2][1], points[0][3]]  ]
		# rect 3 neg ratio
		self.triangles += [ [ points[2][2], points[2][3], points[0][1]]  ]
		self.triangles += [ [ points[2][2], points[2][3], points[0][2]]  ]
		# inter rectangle :) - trial and error
		self.triangles += [ [ points[0][0], points[1][0], points[2][0]]  ]
		self.triangles += [ [ points[0][2], points[1][2], points[2][2]]  ]
		self.triangles += [ [ points[0][1], points[1][3], points[2][2]]  ]
		self.triangles += [ [ points[0][3], points[1][2], points[2][1]]  ]
		self.triangles += [ [ points[0][3], points[1][1], points[2][0]]  ]
		self.triangles += [ [ points[0][0], points[1][3], points[2][1]]  ]
		self.triangles += [ [ points[0][2], points[1][1], points[2][3]]  ]
		self.triangles += [ [ points[0][1], points[1][0], points[2][3]]  ]
		
		#self.triangles += [ [ points[0][2], points[1][1], points[2][3]]  ]
		#self.triangles += [ [ points[0][2], points[1][1], points[2][3]]  ]
		
		# set up colors
		self.colors = [
			(0,0,1),(0,1,0),(1,0,0),
			(1,1,0),(1,0,1),(0,1,1),
			(1,0.5,0.5),(0.5,1,0.5),(0.5,0.5,1),
			(1,1,0.5),(1,1,0.5),(1,0.5,1),
			(0.5,0.5,0.5),
			(0.3,0.8,0.3),(0.8,0.3,0.3),(0.3,0.3,0.8),
			(0.8,0.8,0.3),(0.8,0.3,0.8),(0.3,0.8,0.8),
			(0.8,0.8,0.8),(0.3,0.3,0.3),
			]
		self.color_index = 0
	def __call__(self,window):
		if self.dead:
			return
		window.lock()
		try:
			try:
				if not self.context:
					self.context = zort.plugins.opengl.OpenGL.createContext(window)
				self.context.makeCurrent(window)
				self.spinned_x += 0.4
				self.spinned_y += 0.6
				gl = zort.plugins.opengl.gl
				glu = zort.plugins.opengl.glu
				# init
				#print window.width(), window.height()
				gl.Viewport(0, 0, window.width(), window.height())
				gl.MatrixMode(gl.GL_PROJECTION)
				gl.LoadIdentity()
				glu.Perspective(60.0, float(window.width())/float(window.height()), 0.1, 100.0)
				gl.MatrixMode(gl.GL_MODELVIEW)
				gl.ClearColor(0.0, 0.0 ,0.0, 0.0)
				gl.Enable(gl.GL_DEPTH_TEST)
				gl.Disable(gl.GL_CULL_FACE)
				# end init
				gl.LoadIdentity()
				gl.Translatef(0.0, 0.0, -2.0)
				gl.Rotatef(self.spinned_y,0.0,1.0,0.0)
				gl.Rotatef(self.spinned_x,1.0,0.0,0.0)
				gl.Clear(gl.GL_COLOR_BUFFER_BIT | gl.GL_DEPTH_BUFFER_BIT)
				gl.Begin(gl.GL_TRIANGLES)
				self.color_index = len(self.colors)
				for triangle in self.triangles:
					self.color_index+=1
					if self.color_index>=len(self.colors):
						self.color_index=0
					for point in triangle:
						gl.Color3f(*self.colors[self.color_index])
						gl.Vertex3f([point[0],point[1],point[2]])
				gl.End()
				self.context.swapBuffers(window)
			except Exception, e:
				print "exception: ",str(e)
				self.dead = True
		finally:
			window.unlock()

def window_update_function():
	return zort.globals["example_draw2_class"]()
	global funky_draw
	return funky_draw()

## set update function

if first_run:
	zort.globals["developing_window"] = window = zort.plugins.opengl.OpenGL.createWindow(400,400,"develop window")
	zort.globals["developing_window_timer"] = timer = zort.plugins.timing.Timing.timer(60)
	zort.globals["developing_window_event"] = event = zort.plugins.timing.Timing.createEvent()
	zort.globals["developing_window_update"] = window_update_function()
	timer.event = event
	event.connect( lambda: zort.globals["developing_window_update"](zort.globals["developing_window"]) )
	event.connect( zort.globals["example_fps_counter_class"]("developing window",timer=timer) )

zort.globals["developing_window_update"] = window_update_function()

#####
#zort.globals[]




